<?php /* meta-entry
displays the meta information selected in the theme options at the top of each entry
returns comment instead of empty div if nothing to show
*/

if( !isset( $magomra_options ) ) $magomra_options = get_option( 'magomra-theme-options', magomra_default_options() ); 
	$magomra_text_ssep = ' ' . $magomra_options['body_sep_char'] . ' ';

// check if we have anything to show
	if( $magomra_options['post_author'] != 'none' 
	|| $magomra_options['published_date'] != 'none' 
	|| $magomra_options['updated_date'] != 'none' ) {

	echo '<div class="entry-meta">';

	// author
	if( $magomra_options['post_author'] != 'none' ) {
		
		$magomra_flipper = 1; // switch to know if we need a leading seperator or not
		
		// author_link or name_only
		$magomra_p1 = $magomra_p3 = $magomra_p4 = $magomra_p5 = ''; 
		if( $magomra_options['post_author'] == 'author_link' ) { 
			$magomra_p1 = '<a href="' . get_author_posts_url( get_the_author_meta( 'ID' ), get_the_author_meta( 'user_nicename' ) ) . '" title="View all posts by ';
			$magomra_p3 = '" rel="author">';
			$magomra_p4 = get_the_author();
			$magomra_p5 = '</a>';
		}

		printf( '<span class="entry-meta-pre entry-pre">By </span><span class="entry-meta-item entry-item">%1$s%2$s%3$s%4$s%5$s</span>', $magomra_p1, get_the_author(), $magomra_p3, $magomra_p4, $magomra_p5 );	
	}

	// published date
	if( $magomra_options['published_date'] != 'none' ) { 

		if( $magomra_flipper ) echo $magomra_text_ssep; $magomra_flipper = 1; // check if flipped and flip
		
		// date or date_time
		$magomra_p1 = get_the_date();
		
		if( $magomra_options['published_date'] == 'date_time' ) 
			$magomra_p2 = ' at ' . get_the_time();
		else $magomra_p2 = '';
		
		
		printf( '<span class="entry-meta-pre entry-pre">Published </span><span class="entry-meta-item entry-item">%1$s%2$s</span>', $magomra_p1, $magomra_p2 ); 
	}

	// last updated date
	if( $magomra_options['updated_date'] != 'none' ) { 
		
		if( $magomra_flipper ) echo $magomra_text_ssep; $magomra_flipper = 1; // check if flipped and flip
		
		// date or date_time
		$magomra_p1 = get_the_modified_date();
		if( $magomra_options['updated_date'] == 'date_time' ) // date format from WP options
			$magomra_p2 = ' at ' . get_the_modified_time();	
		else $magomra_p2 = '';
		
		printf( '<span class="entry-meta-pre entry-pre">Last Updated </span><span class="entry-meta-item entry-item">%1$s%2$s</span>', $magomra_p1, $magomra_p2 ); 
	}

	// edit post link
	if( !isset( $magomra_options['edit_link'] ) )
		edit_post_link( 'Edit', $magomra_text_ssep . '<span class="edit-link">', '</span>'); 
	
	echo '</div><!-- /entry-meta -->';	
}

else echo '<!-- no entry-meta -->';
?>