<?php get_header(); ?>
<?php if( !isset( $magomra_options ) ) $magomra_options = get_option( 'magomra-theme-options', magomra_default_options() ); ?>

<?php if( $magomra_options['sidebar_location'] == 'left' ) get_sidebar(); ?>

<div id="content">
<?php while ( have_posts() ) : the_post() ?>
	<div id="post-<?php the_ID(); ?>" <?php post_class(); ?>>

		<?php // safely get post title
		$magomra_title_attribute = the_title_attribute( array( 'echo' => false ) );
		$magomra_post_title = get_the_title();
		
			if( empty( $magomra_title_attribute ) ) {
				$magomra_title_attribute = 'this post';
				$magomra_post_title = '(no title)';
			}

		printf( '<h2 class="entry-title"><a href="%1$s" title="Permalink to %2$s" rel="bookmark">%3$s</a></h2>',
			get_permalink(),
			$magomra_title_attribute,
			$magomra_post_title ); 
		?>
	
	<?php get_template_part( 'index', 'entry_meta' ); ?>
 
		<div class="entry-content">
		<?php if ( has_post_thumbnail() ) the_post_thumbnail( array( 'class' => 'post-thumbnail alignleft' )); ?>
			<?php the_content( $magomra_options['keep_reading_text'] ); ?>
			

		</div><!-- /entry-content -->
		
		<div class="entry-content-footer">
			<?php if( isset( $magomra_options['icon_area'] ) ) { ?>
				<div class="magomra-icon-box"><?php get_template_part( 'index', 'icon_area' ); ?></div><?php } ?>
			<?php wp_link_pages( 'before=<div class="page-link">Pages: &after=</div>' ); ?>
		</div>		
 
		<div class="entry-utility">
			<span class="meta-pre">Posted in </span>
			<span class="meta-categories"><?php echo get_the_category_list(', '); ?></span>
			<span class="meta-sep"> | </span>
			<?php the_tags( '<span class="meta-pre">Tagged </span><span class="tag-links">', ', ', '</span><span class="meta-sep"> | </span>' ) ?>
			<span class="comments-link"><?php comments_popup_link( 'Leave a comment', '1 Comment', '% Comments' ); ?> </span>
			
	<?php
	// edit post link
	if( !isset( $magomra_options['edit_link'] ) )
		edit_post_link( 'Edit', ' ' . $magomra_options['body_sep_char'] . ' ' . '<span class="edit-link">', '</span>'); ?>
		
		</div><!-- /entry-utility -->
	</div><!-- /post-<?php the_ID(); ?>-->

<?php endwhile; ?>

		<?php magomra_index_nav(); ?>

</div><!-- /content -->

<?php if( $magomra_options['sidebar_location'] != 'left' ) get_sidebar(); ?>


<?php get_footer(); ?>