<?php
function magomra_register_options() {
// register theme options
	register_setting( 'magomra-theme-options-group', 'magomra-theme-options', 'magomra_sanatize_input' );
}

// sanatize form input
function magomra_sanatize_input( $input ) {
	return $input;
}

// array of options page elements
function magomra_build_options() {
	$magomra_options = array (
		
		// SECTION: Display Options
		array( 
			'name' => 'Meta Information', 
			'desc' => 'Options for displaying or hiding certain text and metadata.',
			'type' => 'section'
		),
	
		// show authors
		array( 
			'name' => 'Show post author?',
			'id' => 'post_author',
			'desc' => 'Show the name of the post author, name with link to author page, or no author?',
			'type' => 'radio',
			'options' => array( 'none' => 'don\'t show', 'name_only' => 'name only', 'author_link' => 'name &amp; author link' ),
			'default' => 'author_link'
		),
	
		// show published dates
		array( 
			'name' => 'Show publication date?',
			'id' => 'published_date',
			'desc' => 'Show the date and/or time a post or page was published?',
			'type' => 'radio',
			'options' => array( 'none' => 'don\'t show', 'date' => 'date only', 'date_time' => 'date and time' ),
			'default' => 'date'
			),
			
		array( 
			'name' => 'Show last updated date?',
			'id' => 'updated_date',
			'desc' => 'Display the date and/or time when each post or page was last updated?',
			'type' => 'radio',
			'options' => array( 'none' => 'don\'t show', 'date' => 'date only', 'date_time' => 'date and time' ),
			'default' => 'none'
			),
			
		array( 
			'name' => 'Post excerpt link text:',
			'id' => 'keep_reading_text',
			'desc' => 'Text to show for the link at the end of post excerpts.',
			'type' => 'text',
			'default' => 'Continue reading &raquo;'
			),
		
		array( 
			'name' => 'Background color:',
			'id' => 'bg_color',
			'desc' => 'Color of the background in CSS names or hex values.',
			'type' => 'text',
			'default' => '#ddd',
			'notice' => 'This method is depreciated in version 3.4 of WordPress.'
			),
			

		array( 'type' => 'close' ),
		
		array( 
			'name' => 'Layout',
			'desc' => 'Configure how your blog is laid out to users.',
			'type' => 'section'
		),


		array( 
			'name' => 'Sidebar position:',
			'id' => 'sidebar_location',
			'desc' => 'Should the sidebar be to the left or right of the main content?',
			'type' => 'radio',
			'default' => 'right',
			'options' => array( 'left'=> 'left', 'right' => 'right' )
			),
			
		array( 
			'name' => 'Title seperator character:',
			'id' => 'title_sep_char',
			'desc' => 'The character used to seperate pieces of information in the title.',
			'type' => 'text',
			'default' => '&raquo;'
			),
		
		array( 
			'name' => 'Body seperator character:',
			'id' => 'body_sep_char',
			'desc' => 'The character used to seperate strings of text or links in the body.',
			'type' => 'text',
			'default' => '|'
			),
			
		array( 
			'name' => 'Footer seperator character:',
			'id' => 'footer_sep_char',
			'desc' => 'The character used to seperate strings of text or links in the footer.',
			'type' => 'text',
			'default' => '&bull;'
			),
		
	array( 'type' => 'close' ),
	
	array( 
		'name' => 'Utility Text',
		'desc' => 'Configure what messages are shown to users and edit their syntax.',
		'type' => 'section'
	),
		array( 
			'name' => 'Post comment message:',
			'id' => 'post_comment_message',
			'desc' => 'The text to display under the new comment form. Can contain HTML tags. Leave blank for no message.',
			'type' => 'textarea',
			'default' => 'Your email address will <em>never</em> be published.'
			),

	
	array( 'type' => 'close' ),
	
	array( 
		'name' => 'Custom Code',
		'desc' => 'Section to insert custom code to run from various locations within the theme.',
		'type' => 'section'
	),

	array( 
			'name' => 'Enable Icon Area?',
			'id' => 'icon_area',
			'desc' => 'Execute code in a specially styled div in the lower left of the post. Useful for small ratings or social media widgets.',
			'type' => 'checkbox',
			'notice' => 'If this option is enabled, you will have to use the Theme Editor to paste into the <code>index-icon_area.php</code> file. If you need to insert a shortcode, you can use the code <code>&lt;php do_shortcode(\' [theshortcode] \'); ?&gt;</code> in the icon_area file. (WordPress themes are not permitted to pass custom PHP code through the options page for security reasons, sorry.)'
			),

	array( 
			'name' => 'Header code:',
			'id' => 'header_code',
			'desc' => 'Code to be executed right before the &lt;/head&gt; tag.',
			'type' => 'textarea',
			'default' => NULL
			),
	
	array( 
			'name' => 'Footer code:',
			'id' => 'footer_code',
			'desc' => 'Code to be executed right before the &lt;/body&gt; tag.',
			'type' => 'textarea',
			'default' => NULL
			),

	array( 
			'name' => 'After attachment code:',
			'id' => 'attachment_code',
			'desc' => 'Code to be executed on attachment pages, between the description and view previous/next.',
			'type' => 'textarea',
			'default' => NULL
			),

	array( 
			'name' => 'Custom CSS:',
			'id' => 'css_code',
			'desc' => 'Style sheet information to be enqueued in WordPress.',
			'type' => 'textarea',
			'default' => NULL
			),
	
	array( 
			'name' => 'Remove W3C Noncompliant Attributes?',
			'id' => 'w3c_comply',
			'desc' => 'Removes a handful of element attributes that are not W3C compliant',
			'type' => 'checkbox',
			'notice' => 'See <a href="http://wikiduh.com/1390/forcing-w3c-compliance-on-wordpress-elegantly" target="_blank">this article</a> for an explaination.'
			),
	
	array( 'type' => 'close' ),

	array( 
		'name' => 'Editing',
		'desc' => 'Configure backend administrator options for editing.',
		'type' => 'section'
	),
		
	array(
		'name' => 'Hide the post "Edit" links shown to administrators?',
		'id' => 'edit_link',
		'desc' => 'Select or hide the administrator edit links from individual posts.',
		'type' => 'checkbox',
	),
	
	array( 'type' => 'close' )
	);

return $magomra_options; 
}

// returns array of default options
function magomra_default_options() {
	$default_options = array();
	$magomra_options = magomra_build_options();
	foreach( $magomra_options as $magomra_option )
		if( isset( $magomra_option['default'] ) ) 
			$default_options = array_merge( $default_options, array( $magomra_option['id'] => $magomra_option['default'] ) );

	return $default_options;
}

// enque options page supporting CSS and scripts
function magomra_theme_options_init() {
	wp_enqueue_style( 'magomra-theme-options-style', get_template_directory_uri() . '/options/theme-options.css' );
}

//create menu link in Appearance menu
function magomra_create_menu() {
	add_theme_page( 'Magomra Theme Options', 'Theme Options', 'edit_theme_options', 'magomra-theme-options', 'magomra_options_page' );
}

// draw options page
function magomra_options_page() {
if( isset( $_POST['reset'] ) ) {
	delete_option( 'magomra-theme-options' );
	wp_cache_flush(); 
	add_option( 'magomra-theme-options', magomra_default_options(), NULL, false );
	echo '<div class="updated settings-error"><p><strong>Magomra theme options reset to defaults.</strong></p></div>';
}

elseif( isset( $_REQUEST['settings-updated'] ) )
	echo '<div class="updated settings-error"><p><strong>Magomra theme options saved.</strong></p></div>';

?>

<div class="wrap">
<?php screen_icon(); ?><h2>Magomra Theme Options</h2>

<div id="magomra-options-container">
<form method="post" action="options.php">

<?php 
settings_fields( 'magomra-theme-options-group' ); 
$options = get_option( 'magomra-theme-options', magomra_default_options() );
$magomra_options = magomra_build_options();

foreach( $magomra_options as $item ) {

if( isset( $item['id']) ) $item_id = $item['id'];

switch ( $item['type'] ) {

case 'section' : ?>

<div class="magomra-options-section">
	<div class="magomra-options-header">
		<h3 class="magomra-options-section-title" title="<?php echo $item['desc']; ?>"><?php echo $item['name']; ?></h3>
	</div><!-- /.magomra-options-header -->
<?php break;

case 'text': ?>

	<div class="magomra-option-holder">
		<div class="magomra-option-item"><label for="<?php echo 'magomra-theme-options[' . $item_id . ']'; ?>" title="<?php echo $item['desc']; ?>"><?php echo $item['name']; ?></label></div><div class="magomra-option-input">
		<input name="<?php echo 'magomra-theme-options[' . $item_id . ']'; ?>" id="<?php echo 'magomra-theme-options[' . $item_id . ']'; ?>" type="<?php echo $item['type']; ?>" value="<?php if( isset(  $options[$item_id] ) ) esc_attr_e( $options[$item_id] ); else esc_attr_e( $item['default'] ); ?>" /></div><?php if( isset( $item['notice'] ) ) echo '<div class="magomra-option-notice">' . $item['notice'] . '</div>'; ?>
	</div>

<?php break;

case 'textarea': ?>

	<div class="magomra-option-holder">
	<div class="magomra-option-item">
	<label for="<?php echo 'magomra-theme-options[' . $item_id . ']'; ?>" title="<?php echo $item['desc']; ?>"><?php echo $item['name']; ?></label></div><div class="magomra-option-input">
		<textarea name="<?php echo 'magomra-theme-options[' . $item_id . ']'; ?>" type="<?php echo 'magomra-theme-options[' . $item_id . ']'; ?>" cols="" rows=""><?php if( isset( $options[$item_id] ) )  esc_attr_e( $options[$item_id] ); else esc_attr_e( $item['default'] ); ?></textarea>
		</div><?php if( isset( $item['notice'] ) ) echo '<div class="magomra-option-notice">' . $item['notice']	 . '</div>'; ?>
		</div>

<?php break;

case 'select': ?>

<div class="magomra-option-holder">
<div class="magomra-option-item">
<label for="<?php echo 'magomra-theme-options[' . $item_id . ']'; ?>" title="<?php echo $item['desc']; ?>"><?php echo $item['name']; ?></label></div><div class="magomra-option-input">
		<select name="<?php echo 'magomra-theme-options[' . $item_id . ']'; ?>" id="<?php echo 'magomra-theme-options[' . $item_id . ']'; ?>">
		<?php foreach( $item['options'] as $suboption ) { ?>
				<option <?php if ( $options[$item_id] == $suboption) { echo 'selected="selected"'; } ?>><?php echo $suboption; ?></option>
		<?php } ?>
		</select>
		</div><?php if( isset( $item['notice'] ) ) echo '<div class="magomra-option-notice">' . $item['notice']	 . '</div>'; ?></div>

<?php break;

case "radio": ?>

<div class="magomra-option-holder">
<div class="magomra-option-item">
<label for="<?php echo 'magomra-theme-options[' . $item_id . ']'; ?>" title="<?php echo $item['desc']; ?>"><?php echo $item['name']; ?></label></div><?php 
		foreach ( $item['options'] as $key=>$suboption) {
			if( isset( $options[$item_id] ) ) {
				if( $key == $options[$item_id] ) { $checked = 'checked="checked"'; }
				else { $checked = NULL; }
			} 
			
			else {
				if( $key == $item['default'] ) { $checked = 'checked="checked"'; }
				else { $checked = NULL; }
			} ?>
			
			<div class="magomra-option-input"><input type="radio" id="<?php echo 'magomra-theme-options[' . $item_id . ']'; ?>" name="<?php echo 'magomra-theme-options[' . $item_id . ']'; ?>" value="<?php echo $key; ?>" <?php echo $checked; ?> /><?php echo $suboption; ?>
		</div><?php } ?><?php if( isset( $item['notice'] ) ) echo '<div class="magomra-option-notice">' . $item['notice']	 . '</div>'; ?></div>

<?php break;

case "checkbox": ?>

	<?php if( isset( $options[$item_id] ) ) $checked = 'checked="checked"'; else $checked = NULL; ?>

<div class="magomra-option-holder">
<div class="magomra-option-item">
<label for="<?php echo 'magomra-theme-options[' . $item_id . ']'; ?>" title="<?php echo $item['desc']; ?>"><?php echo $item['name']; ?></label></div><div class="magomra-option-input"><input type="checkbox" name="<?php echo 'magomra-theme-options[' . $item_id . ']'; ?>" id="<?php echo 'magomra-theme-options[' . $item_id . ']'; ?>" value="1" <?php echo $checked; ?> />
</div><?php if( isset( $item['notice'] ) ) echo '<div class="magomra-option-notice">' . $item['notice'] . '</div>'; ?>
</div>

<?php break;

case "close": ?>

</div><!-- /.magomra-options-section -->

<?php break;
	}
}
?>
<div class="magomra-options-submit-container">
	<div class="submit">
		<input class="button button-primary" type="submit" name="save" value="Save All Changes" />
	</div>
	</form>

	<form method="post" action="">
		<div class="button-right" type="submit">
			<input class="button button-secondary" type="submit" name="reset" value="Reset to Defaults" />
			<input type="hidden" name="action" value="reset" />
		</div>
	</form>
</div><!-- /.magomra-options-submit-container -->

</div><!-- /.magomra-options-container -->

<?php 
} 

// Hooks & Filters
add_action( 'admin_init', 'magomra_register_options' ); // register theme settings
add_action( 'admin_menu', 'magomra_create_menu' );
add_action( 'admin_init', 'magomra_theme_options_init' );
?>